C.........................................................DEC 2021
C 360 (from 381) HSS/DST storms // before March 2018
C
C USE input files: 'd:/apkp/ae/wwwaeYEAR.dat'
C........................................................Jan.2020
C Extract AL-index for -24h<t0< +48h for 455 HSS/Dst ~ 444 AE events 
C 
C Select period of 72hrs starting from t0-24h, ending t0+48h; t0 @ Vswmax_hour
C 
      PROGRAM decodkp5ALd
C Input HSSUT.txt 1996-2010...........................Jan 2020
C add: select from -24h < to <+48h for HSS-events
C
C----------------------------------------------------------------
C
	DIMENSION inae(0:71) ! 1h indices for 24h (or 72h file for 1h indices)
	+,ind24(0:23)
C
	CHARACTER*4 AYEAR
      CHARACTER*128 INFILE,INFHSS
	+,outfilae  !AE
	       CHARACTER*52 TXT
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
C++
C
      ICALLS=0
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
C
C--	infile='d:/apkp/AE/alYEAR' !AL
      infile='d:/apkp/AE/wwwaeYEAR.dat'  ! AL
C
	outfilae='hssal3d.txt' !total file for 1996-2019 =1263 lines x 24 cols superposed epoch
	OPEN(11,FILE=OUTFILAE)
C
C HSS 1263 storms from 1994 to 2019
C
   28 format(1X,F8.3,3(1X,I2),3(1X,F6.0))
C   29 format(1X,F8.3,1X,I3,2(1X,I2),1X,I3,1X,F6.0,1X,I2,2(1X,F6.0))
   29 format(1X,F8.3,1X,I3,3(1X,I2),1X,I4,2(1X,I4),1X,I3,2(1X,I4))
	infhss='catdsthss3.txt' ! 455 HSS/AE events
	open(10,file=infhss,action='READ')
C	read(10,*) txt ! title line
C
C Cycle on events ====================================================
C
	DO 177 iev=1,360
c	read(10,29,end=27) ryear1,ldam,imn1,idy1,iutm,v1,iut1,v2,delv
      read(10,29,end=27) ryear1,lda1,imn1,idy1,iut1,idstpeak,ivmin
	+,idelsw,idt,ivmax,nout
C	if (ryear1.gt.2018.) goto 177
	iutcnt=0
	do k=0,71
	inae(k)=0
	enddo
	iyear=int(ryear1)
	iyr=iyear-iyear/100*100
C
	lda1=ndoy(iyr,imn1,idy1) ! 1d
      lda0=lda1-1 ! -1d
	lda2=lda1+2
C
   37 format(20X,24(I4))	 ! AE
C
	if (lda0.eq.0) then  !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C
C read last day of prec. year:
C
	iyear0=iyear-1
       call blet4(iyear0,AYEAR)
      infile(17:20)=AYEAR
	open(15,file=infile,action='READ')
	ryear0=float(iyear0)
		if(int(ryear0/4.)*4.eq.iyear0) THEN 
	ndnyr=366
	                          ELSE
	ndnyr=365
	ENDIF

	DO 101 k=1,ndnyr
       DO ii=0,23
	read(15,38,end=103) txt,xal
	ind24(ii)=nint(xal)
      ENDDO
  101	CONTINUE
  102	close(unit=15)
C last day of prec year from iut1 to 23 h:   
       DO ii=iut1,23
       inae(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
	ENDDO
	endif				 !>>>>>>>>>>>>>>>>>>>>>>>>
C
   38 FORMAT(A52,F8.2)
C Prec. day from current year:
       call blet4(iyear,AYEAR)
	infile(17:20)=AYEAR
	open(15,file=infile,action='READ')
C
	if (lda0.gt.0) then !>>>>>>>>>>>>>>>>>>>>>>>>>>>
	DO 109 k=1,lda0
       DO ii=0,23
	read(15,38,end=103) txt,xal
	ind24(ii)=nint(xal)
      ENDDO
  109	CONTINUE
       DO ii=iut1,23
       inae(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
	ENDDO
	endif				 !>>>>>>>>>>>>>>>>>>>>>>>>
C 1st day from current year:
       DO ii=0,23
	read(15,38,end=103) txt,xal
	ind24(ii)=nint(xal)
      ENDDO
C	  1st day :
       DO ii=0,23
       inae(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
	ENDDO
C 2nd day from current year:
       DO ii=0,23
	read(15,38,end=103) txt,xal
	ind24(ii)=nint(xal)
      ENDDO
C	  2nd day :
       DO ii=0,23
       inae(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
	ENDDO
C 3rd day from current year:
       DO ii=0,23
	read(15,38,end=103) txt,xal
	ind24(ii)=nint(xal)
      ENDDO
C	  3rd day :
       DO ii=0,23
	if (iutcnt.lt.72) then
       inae(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
              	else
	exit
              	endif
	ENDDO
  103	close(unit=15)
C
C Next year if necessary:
       if (iutcnt.lt.72) then   !>>>>>>>>>>>>>>>>>>>>>>>>>>>
	iyear1=iyear+1
	call blet4(iyear1,AYEAR)
	infile(17:20)=AYEAR
	open(15,file=infile,action='READ')
C
       DO ii=0,23
	read(15,38,end=103) txt,xal
	ind24(ii)=nint(xal)
      ENDDO
C	  next day :
       DO ii=0,23
	if (iutcnt.lt.72) then
       inae(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
              	else
	exit
              	endif
	ENDDO
  104	close(unit=15)
      endif	                !>>>>>>>>>>>>>>>>>>>>>
C
  138 format(72(1X,I5))
C Output matrices:
 	write(*,138) (inae(k),k=0,71)
	write(11,138) (inae(k),k=0,71)
  177	CONTINUE
   27 close(unit=10)
      close(unit=11)
C
C
   35      write(*,*) infile
      pause ' ' 
      STOP
       END

C***********************************************************
